# remirepo/Fedora spec file for php-zendframework-zend-validator
#
# Copyright (c) 2015-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    38109ed7d8e46cfa71bccbe7e6ca80cdd035f8c9
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-validator
%global php_home     %{_datadir}/php
%global library      Validator
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.10.2
Release:        1%{?dist}
Summary:        Zend Framework %{library} component

Group:          Development/Libraries
License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-ctype
BuildRequires:  php-date
BuildRequires:  php-fileinfo
BuildRequires:  php-hash
BuildRequires:  php-intl
BuildRequires:  php-pcre
BuildRequires:  php-spl
BuildRequires:  php-composer(%{gh_owner}/zend-stdlib)             >= 2.7.6
BuildRequires:  php-composer(container-interop/container-interop) >= 1.1
# From composer, "require-dev": {
#        "zendframework/zend-cache": "^2.6.1",
#        "zendframework/zend-config": "^2.6",
#        "zendframework/zend-db": "^2.7",
#        "zendframework/zend-filter": "^2.6",
#        "zendframework/zend-http": "^2.5.4",
#        "zendframework/zend-i18n": "^2.6",
#        "zendframework/zend-math": "^2.6",
#        "zendframework/zend-servicemanager": "^2.7.5 || ^3.0.3",
#        "zendframework/zend-session": "^2.8",
#        "zendframework/zend-uri": "^2.5",
#        "phpunit/PHPUnit": "^6.0.8 || ^5.7.15",
#        "zendframework/zend-coding-standard": "~1.0.0"
BuildRequires:  php-composer(%{gh_owner}/zend-cache)            >= 2.6.1
BuildRequires:  php-composer(%{gh_owner}/zend-config)           >= 2.6
BuildRequires:  php-composer(%{gh_owner}/zend-db)               >= 2.7
BuildRequires:  php-composer(%{gh_owner}/zend-filter)           >= 2.6
BuildRequires:  php-composer(%{gh_owner}/zend-http)             >= 2.5.4
BuildRequires:  php-composer(%{gh_owner}/zend-i18n)             >= 2.6
BuildRequires:  php-composer(%{gh_owner}/zend-math)             >= 2.6
BuildRequires:  php-composer(%{gh_owner}/zend-servicemanager)   >= 2.7.5
BuildRequires:  php-composer(%{gh_owner}/zend-session)          >= 2.8
BuildRequires:  php-composer(%{gh_owner}/zend-uri)              >= 2.5
%if 0%{?fedora} >= 26
%global phpunit %{_bindir}/phpunit6
%else
%global phpunit %{_bindir}/phpunit
%endif
BuildRequires:  %{phpunit}
# Autoloader
BuildRequires:  php-composer(%{gh_owner}/zend-loader)           >= 2.5
%endif

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "zendframework/zend-stdlib": "^2.7.6 || ^3.1",
#        "container-interop/container-interop": "^1.1"
Requires:       php(language) >= 5.5
%if ! %{bootstrap}
Requires:       php-composer(%{gh_owner}/zend-stdlib)             >= 2.7.6
Requires:       php-composer(%{gh_owner}/zend-stdlib)             <  4
Requires:       php-composer(container-interop/container-interop) >= 1.1
Requires:       php-composer(container-interop/container-interop) <  2
# From composer, "suggest": {
#        "zendframework/zend-db": "Zend\\Db component, required by the (No)RecordExists validator",
#        "zendframework/zend-filter": "Zend\\Filter component, required by the Digits validator",
#        "zendframework/zend-i18n": "Zend\\I18n component to allow translation of validation error messages",
#        "zendframework/zend-math": "Zend\\Math component, required by the Csrf validator",
#        "zendframework/zend-i18n-resources": "Translations of validator messages",
#        "zendframework/zend-servicemanager": "Zend\\ServiceManager component to allow using the ValidatorPluginManager and validator chains",
#        "zendframework/zend-session": "Zend\\Session component, ^2.8; required by the Csrf validator",
#        "zendframework/zend-uri": "Zend\\Uri component, required by the Uri and Sitemap\\Loc validators"
%if 0%{?fedora} >= 21
Suggests:       php-composer(%{gh_owner}/zend-db)
Suggests:       php-composer(%{gh_owner}/zend-filter)
Suggests:       php-composer(%{gh_owner}/zend-i18n)
Suggests:       php-composer(%{gh_owner}/zend-math)
Suggests:       php-composer(%{gh_owner}/zend-i18n-resources)
Suggests:       php-composer(%{gh_owner}/zend-servicemanager)
Suggests:       php-composer(%{gh_owner}/zend-session)
Suggests:       php-composer(%{gh_owner}/zend-uri)
%endif
%endif
# From phpcompatinfo report for version 2.10.1
Requires:       php-ctype
Requires:       php-date
Requires:       php-fileinfo
Requires:       php-hash
Requires:       php-intl
Requires:       php-pcre
Requires:       php-spl

Obsoletes:      php-ZendFramework2-%{library} < 2.5
Provides:       php-ZendFramework2-%{library} = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}


%description
The Zend\Validator component provides a set of commonly needed validators.
It also provides a simple validator chaining mechanism by which multiple
validators may be applied to a single datum in a user-defined order.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
# Empty build section, nothing required


%install

mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{php_home}/Zend/Loader/AutoloaderFactory.php';
Zend\Loader\AutoloaderFactory::factory(array(
    'Zend\Loader\StandardAutoloader' => array(
        'namespaces' => array(
           'ZendTest\\%{library}' => dirname(__DIR__).'/test/',
           'Zend\\%{library}'     => '%{buildroot}%{php_home}/Zend/%{library}'
))));
require_once '%{php_home}/Zend/autoload.php';
EOF

# PHP 7.2 https://github.com/zendframework/zend-validator/issues/196
ret=0
for cmdarg in "php %{phpunit}" php70 php71 php72; do
  if which $cmdarg; then
    set $cmdarg
    $1 -d memory_limit=1G ${2:-%{_bindir}/phpunit6} --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}


%changelog
* Fri Feb  2 2018 Remi Collet <remi@remirepo.net> - 2.10.2-1
- Update to 2.10.2

* Tue Oct 31 2017 Remi Collet <remi@remirepo.net> - 2.10.1-2
- fix FTBFS from Koschei, add patch for test with 7.2 from
  https://github.com/zendframework/zend-validator/pull/205

* Wed Aug 23 2017 Remi Collet <remi@remirepo.net> - 2.10.1-1
- Update to 2.10.1

* Tue Aug 15 2017 Remi Collet <remi@remirepo.net> - 2.10.0-1
- Update to 2.10.0

* Fri Aug  4 2017 Remi Collet <remi@remirepo.net> - 2.9.2-1
- Update to 2.9.2
- add patch for PHP 7.2 from
  https://github.com/zendframework/zend-validator/pull/190

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.9.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Mon May 22 2017 Remi Collet <remi@remirepo.net> - 2.9.1-1
- Update to 2.9.1

* Fri Mar 17 2017 Remi Collet <remi@remirepo.net> - 2.9.0-1
- Update to 2.9.0
- raise dependency on PHP 5.6
- raise dependency on zend-stdlib 2.7.6
- use phpunit6 on F26+

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.8.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Sun Jan 29 2017 Remi Collet <remi@fedoraproject.org> - 2.8.2-1
- Update to 2.8.2

* Tue Nov 15 2016 Remi Collet <remi@fedoraproject.org> - 2.8.1-2
- add patch for PHP 7.1 and timezone changes
- open https://github.com/zendframework/zend-validator/pull/136

* Thu Jun 23 2016 Remi Collet <remi@fedoraproject.org> - 2.8.1-1
- Update to 2.8.1

* Tue May 17 2016 Remi Collet <remi@fedoraproject.org> - 2.8.0-1
- Update to 2.8.0

* Tue Apr 19 2016 Remi Collet <remi@fedoraproject.org> - 2.7.2-1
- Update to 2.7.2

* Wed Apr  6 2016 Remi Collet <remi@fedoraproject.org> - 2.7.1-1
- Update to 2.7.1

* Wed Apr  6 2016 Remi Collet <remi@fedoraproject.org> - 2.7.0-1
- Update to 2.7.0

* Thu Feb 18 2016 Remi Collet <remi@fedoraproject.org> - 2.6.0-1
- Update to 2.6.0
- raise dependency on zend-stdlib ^2.7
- add dependency on container-interop/container-interop

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 2.5.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Oct  1 2015 Remi Collet <remi@fedoraproject.org> - 2.5.3-1
- normal build

* Fri Sep  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.3-0
- Update to 2.5.3, bootstrap build

* Thu Aug  6 2015 Remi Collet <remi@fedoraproject.org> - 2.5.2-2
- fix description

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.2-1
- initial package